//+------------------------------------------------------------------+
//|                     Kaufman Adaptive Moving Average with signals |
//+------------------------------------------------------------------+
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 6
#property indicator_color1  DeepSkyBlue
#property indicator_color2  LimeGreen
#property indicator_color3  LimeGreen
#property indicator_color4  Red
#property indicator_color5  Red
#property indicator_color6  DimGray
#property indicator_style3  STYLE_DOT
#property indicator_style4  STYLE_DOT
#property indicator_style6  STYLE_DOT
#property indicator_width1  2

//
//
//
//
//

#import "dynamicZone.dll"
   double dzBuyP(double& sourceArray[],double probabiltyValue, int lookBack, int bars, int i, double precision);
   double dzSellP(double& sourceArray[],double probabiltyValue, int lookBack, int bars, int i, double precision);
#import

//
//
//
//
//

extern int    AMAPeriod               = 26;
extern int    AMAPrice                = PRICE_CLOSE;
extern int    Nfast                   = 5;
extern int    Nslow                   = 20;
extern double GCoeff                  = 2.0;
extern bool   ShowMiddleLine          = true;
extern int    DzLookBackBars          = 50;
extern double DzStartBuyProbability1  = 0.10;
extern double DzStartBuyProbability2  = 0.25;
extern double DzStartSellProbability1 = 0.10;
extern double DzStartSellProbability2 = 0.25;

//
//
//
//
//

double kAMAbuffer[];
double bl1Buffer[];
double bl2Buffer[];
double sl1Buffer[];
double sl2Buffer[];
double zliBuffer[];
double diff[];

//
//
//
//
//

double fastend;
double slowend;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(7);
   SetIndexBuffer(0,kAMAbuffer);
   SetIndexBuffer(1,bl1Buffer); 
   SetIndexBuffer(2,bl2Buffer); 
   SetIndexBuffer(3,sl2Buffer); 
   SetIndexBuffer(4,sl1Buffer); 
   SetIndexBuffer(5,zliBuffer);
   SetIndexBuffer(6,diff);
   
   
   //
   //
   //
   //
   //
   
      fastend   = (2.0 /(Nfast + 1));
      slowend   = (2.0 /(Nslow + 1));
   
   //
   //
   //
   //
   //
   
   IndicatorShortName("Kaufman AMA signals ("+AMAPeriod+")");
   return(0);
}
int deinit()
{
   return(0);
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;
   
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit = MathMin(Bars-counted_bars,Bars-1);

           //
           //
           //
           //
           //
                      
           if (Digits==3 || Digits==5)
              double _point=Point*10;
           else      _point=Point;         


   //
   //
   //
   //
   //
   
   for(i=limit; i>=0; i--)
   {
      double price = iMA(NULL,0,1,0,MODE_SMA,AMAPrice,i);

         if (i > Bars-AMAPeriod) { kAMAbuffer[i] = price; continue; }
   
         //
         //
         //
         //
         //
   
         double efratio = 1.00;
         double noise   = 0.00;
         double smooth;
         double signal;
             signal  = MathAbs(price-iMA(NULL,0,1,0,MODE_SMA,AMAPrice,i+AMAPeriod));
             diff[i] = MathAbs(price-iMA(NULL,0,1,0,MODE_SMA,AMAPrice,i+1));
                for (int k=0;k<AMAPeriod;k++)
                        noise += diff[i+k];

          //
          //
          //
          //
          //

          if (noise != 0) efratio = signal/noise;
                          smooth        = MathPow(efratio*(fastend-slowend)+slowend,GCoeff);
                          kAMAbuffer[i] = kAMAbuffer[i+1] + smooth*(price-kAMAbuffer[i+1]);
                          
          if (DzStartBuyProbability1 >0) bl1Buffer[i] = dzBuyP (kAMAbuffer, DzStartBuyProbability1,  DzLookBackBars, Bars, i, 0.0001);
          if (DzStartBuyProbability2 >0) bl2Buffer[i] = dzBuyP (kAMAbuffer, DzStartBuyProbability2,  DzLookBackBars, Bars, i, 0.0001);
          if (DzStartSellProbability1>0) sl1Buffer[i] = dzSellP(kAMAbuffer, DzStartSellProbability1, DzLookBackBars, Bars, i, 0.0001);
          if (DzStartSellProbability2>0) sl2Buffer[i] = dzSellP(kAMAbuffer, DzStartSellProbability2, DzLookBackBars, Bars, i, 0.0001);
          if (ShowMiddleLine)            zliBuffer[i] = dzSellP(kAMAbuffer, 0.5                    , DzLookBackBars, Bars, i, 0.0001);

          //
          //
          //
          //
          //
                                    
                             
   }
   return(0);
}